SoVRMLTimeSensor(3)

NAME
SoVRMLTimeSensor - The SoVRMLTimeSensor class is a multi-purpose time event generator.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLTimeSensor.h>

Inherits SoNodeEngine.

  Public Member Functions
virtual SoType getTypeId (void) const
virtual const SoEngineOutputData * getOutputData (void) const
SoVRMLTimeSensor (void)
virtual void notify (SoNotList *list)
virtual void handleEvent (SoHandleEventAction *action)
virtual void write (SoWriteAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void * createInstance (void)
static void initClass (void)

  Public Attributes
SoSFTime cycleInterval
SoSFBool enabled
SoSFBool loop
SoSFTime startTime
SoSFTime stopTime
SoEngineOutput cycleTime
SoEngineOutput fraction_changed
SoEngineOutput isActive
SoEngineOutput time

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVRMLTimeSensor ()
virtual void inputChanged (SoField *whichInput)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
static const SoEngineOutputData ** getOutputDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVRMLTimeSensor class is a multi-purpose time event generator. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

TimeSensor {
  exposedField SFTime   cycleInterval 1       # (0,inf)
  exposedField SFBool   enabled       TRUE
  exposedField SFBool   loop          FALSE
  exposedField SFTime   startTime     0       # (-inf,inf)
  exposedField SFTime   stopTime      0       # (-inf,inf)
  eventOut     SFTime   cycleTime
  eventOut     SFFloat  fraction_changed      # [0, 1]
  eventOut     SFBool   isActive
  eventOut     SFTime   time
}

TimeSensor nodes generate events as time passes. TimeSensor nodes can be used for many purposes including:

•   driving continuous simulations and animations;

•   controlling periodic activities (e.g., one per minute);

•   initiating single occurrence events such as an alarm clock.

The TimeSensor node contains two discrete eventOuts: isActive and cycleTime. The isActive eventOut sends TRUE when the TimeSensor node begins running, and FALSE when it stops running. The cycleTime eventOut sends a time event at startTime and at the beginning of each new cycle (useful for synchronization with other time-based objects). The remaining eventOuts generate continuous events. The fraction_changed eventOut, an SFFloat in the closed interval [0,1], sends the completed fraction of the current cycle. The time eventOut sends the absolute time for a given simulation tick.

If the enabled exposedField is TRUE, the TimeSensor node is enabled and may be running. If a set_enabled FALSE event is received while the TimeSensor node is running, the sensor performs the following actions:

•   evaluates and sends all relevant outputs;

•   sends a FALSE value for isActive;

•   disables itself.

Events on the exposedFields of the TimeSensor node (e.g., set_startTime) are processed and their corresponding eventOuts (e.g., startTime_changed) are sent regardless of the state of the enabled field. The remaining discussion assumes enabled is TRUE.

The e\ loop, startTime, and stopTime exposedFields and the isActive eventOut and their effects on the TimeSensor node are discussed in detail in 4.6.9, Time-dependent nodes (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.9). The 'cycle' of a TimeSensor node lasts for cycleInterval seconds. The value of cycleInterval shall be greater than zero.

A cycleTime eventOut can be used for synchronization purposes such as sound with animation. The value of a cycleTime eventOut will be equal to the time at the beginning of the current cycle. A cycleTime eventOut is generated at the beginning of every cycle, including the cycle starting at startTime. The first cycleTime eventOut for a TimeSensor node can be used as an alarm (single pulse at a specified time).

When a TimeSensor node becomes active, it generates an isActive = TRUE event and begins generating time, fraction_changed, and cycleTime events which may be routed to other nodes to drive animation or simulated behaviours. The behaviour at read time is described below. The time event sends the absolute time for a given tick of the TimeSensor node (time fields and events represent the number of seconds since midnight GMT January 1, 1970).

fraction_changed events output a floating point value in the closed interval [0, 1]. At startTime the value of fraction_changed is 0. After startTime, the value of fraction_changed in any cycle will progress through the range (0.0, 1.0]. At startTime + N cycleInterval, for N = 1, 2, ..., that is, at the end of every cycle, the value of fraction_changed is 1.

Let now represent the time at the current simulation tick. Then the time and fraction_changed eventOuts can then be computed as:

time = now
temp = (now - startTime) / cycleInterval
f = fractionalPart(temp)
if (f == 0.0 && now > startTime) fraction_changed = 1.0
else fraction_changed = f

where fractionalPart(x) is a function that returns the fractional part, (that is, the digits to the right of the decimal point), of a nonnegative floating point number.

A TimeSensor node can be set up to be active at read time by specifying loop TRUE (not the default) and stopTime less than or equal to startTime (satisfied by the default values). The time events output absolute times for each tick of the TimeSensor node simulation. The time events shall start at the first simulation tick greater than or equal to startTime. time events end at stopTime, or at startTime + N cycleInterval for some positive integer value of N, or loop forever depending on the values of the other fields. An active TimeSensor node shall stop at the first simulation tick when now >= stopTime > startTime.

No guarantees are made with respect to how often a TimeSensor node generates time events, but a TimeSensor node shall generate events at least at every simulation tick. TimeSensor nodes are guaranteed to generate final time and fraction_changed events. If loop is FALSE at the end of the Nth cycleInterval and was TRUE at startTime + M cycleInterval for all 0 < M < N, the final time event will be generated with a value of (startTime + N cycleInterval) or stopTime (if stopTime > startTime), whichever value is less. If loop is TRUE at the completion of every cycle, the final event is generated as evaluated at stopTime (if stopTime > startTime) or never.

An active TimeSensor node ignores set_cycleInterval and set_startTime events. An active TimeSensor node also ignores set_stopTime events for set_stopTime less than or equal to startTime. For example, if a set_startTime event is received while a TimeSensor node is active, that set_startTime event is ignored (the startTime field is not changed, and a startTime_changed eventOut is not generated). If an active TimeSensor node receives a set_stopTime event that is less than the current time, and greater than startTime, it behaves as if the stopTime requested is the current time and sends the final events based on the current time (note that stopTime is set as specified in the eventIn).

A TimeSensor read from a VRML file shall generate isActive TRUE, time and fraction_changed events if the sensor is enabled and all conditions for a TimeSensor to be active are met.

Constructor & Destructor Documentation

  SoVRMLTimeSensor::SoVRMLTimeSensor (void)
Constructor.

  SoVRMLTimeSensor::~SoVRMLTimeSensor () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLTimeSensor::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLTimeSensor::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoVRMLTimeSensor::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLTimeSensor::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  const SoEngineOutputData * SoVRMLTimeSensor::getOutputData (void) const [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implements SoNodeEngine.

  void SoVRMLTimeSensor::initClass (void) [static]

  void SoVRMLTimeSensor::notify (SoNotList * l) [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoNodeEngine.

  void SoVRMLTimeSensor::handleEvent (SoHandleEventAction * action) [virtual]
Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoNode.

  void SoVRMLTimeSensor::write (SoWriteAction * action) [virtual]
Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented from SoNode.

  void SoVRMLTimeSensor::inputChanged (SoField * which) [protected], [virtual]
Called when an input is changed. The default method does nothing, but subclasses may override this method to do the The Right Thing when a specific field is changed.

Reimplemented from SoNodeEngine.

Member Data Documentation

  SoSFTime SoVRMLTimeSensor::cycleInterval
The cycle interval. Default value is 1. Must be > 0.

  SoSFBool SoVRMLTimeSensor::enabled
Used to enable/disable timer. Default value is TRUE.

  SoSFBool SoVRMLTimeSensor::loop
TRUE if timer should loop. Default value is FALSE.

  SoSFTime SoVRMLTimeSensor::startTime
The timer start time. Default value is 0.0.

  SoSFTime SoVRMLTimeSensor::stopTime
The timer stop time. Default value is 0.0.

  SoEngineOutput SoVRMLTimeSensor::cycleTime
An eventOut that is sent when a new cycle is started.

  SoEngineOutput SoVRMLTimeSensor::fraction_changed
An eventOut that is sent for each tick, containing a number between 0 and 1.

  SoEngineOutput SoVRMLTimeSensor::isActive
An eventOut that is sent when the timer is enabled/disabled.

  SoEngineOutput SoVRMLTimeSensor::time
An eventOut that is sent for each tick, containing the current time.

Author

Generated automatically by Doxygen for Coin from the source code.